﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows;
using System.Collections.ObjectModel;
using System.Windows.Controls.Primitives;

namespace TestBench
{
	public partial class Page : UserControl
	{
		public Page()
		{
			InitializeComponent();

			dragGrid.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));
			dragGrid.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
			dragGrid.AddHandler(RadDragAndDropManager.DropInfoEvent, new EventHandler<DragDropEventArgs>(OnDropInfo));
			dragGrid.AddHandler(RadDragAndDropManager.DragInfoEvent, new EventHandler<DragDropEventArgs>(OnDragInfo));

			Loaded += new RoutedEventHandler(Page_Loaded);
		}

		void Page_Loaded(object sender, RoutedEventArgs e)
		{
			RadDragAndDropManager.SetAllowDrag(ellipse1, true);
			RadDragAndDropManager.SetAllowDrag(ellipse2, true);
			RadDragAndDropManager.SetAllowDrag(ellipse3, true);
		}

		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragQuery)
			{
				e.QueryResult = true;

				//The DragAndDropmanager will detach the element and drag it around the screen. 
				var source = e.Options.Source as Ellipse;
				source.Visibility = Visibility.Collapsed;

				e.Options.Payload = source;
				e.Options.DragCue = new Ellipse() { Fill = source.Fill, Width = 100, Height = 100 };

				e.Handled = true;
			}

			if (e.Options.Status == DragStatus.DropSourceQuery)
			{
				e.QueryResult = true;
			}
		}

		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DropDestinationQuery)
			{
				e.QueryResult = true;
			}
		}

		private void OnDragInfo(object sender, DragDropEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragCancel)
			{
				e.Options.Source.Visibility = Visibility.Visible;
			}
		}

		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			if (e.Options.Status == DragStatus.DropComplete)
			{
				Grid.SetColumn(e.Options.Source, Grid.GetColumn(e.Options.Destination));
				Grid.SetRow(e.Options.Source, Grid.GetRow(e.Options.Destination));

				e.Options.Source.Visibility = Visibility.Visible;

				e.Handled = true;
			}
		}
	}
}
